'*******************************************************************************
'
' VARIABLES GLOBALES
'
'*******************************************************************************

dim shared Occupant(-1 to 10, -1 to 10) as byte' Position des pices
dim shared Trait                        as byte' Couleur active
dim shared Primo(3)                     as ubyte' Roque (premire condition)
dim shared CarreauPassant               as string' Prise en passant
dim shared CompteDemiCoups              as ushort' Halfmove clock
dim shared CompteCoups                  as ushort' Fullmove number
dim shared Eschec                       as ubyte
dim shared Secundo(3)                   as ubyte ' Roque (deuxime condition)
dim shared Partie                       as string

'*******************************************************************************

const Vide=0
const Pion=1
const Cavalier=2
const Fou=3
const Tour=4
const Dame=5
const Roi=6
const HorsJeu=7
const Blanc=1
const Noir=-1
const e8c8=0
const e8g8=1
const e1c1=2
const e1g1=3
const Faux=0
const Vrai=1

'*******************************************************************************

data -4,-2,-3,-5,-6,-3,-2,-4
data -1,-1,-1,-1,-1,-1,-1,-1
data  0, 0, 0, 0, 0, 0, 0, 0
data  0, 0, 0, 0, 0, 0, 0, 0
data  0, 0, 0, 0, 0, 0, 0, 0
data  0, 0, 0, 0, 0, 0, 0, 0
data  1, 1, 1, 1, 1, 1, 1, 1
data  4, 2, 3, 5, 6, 3, 2, 4

'*******************************************************************************

declare sub Initialise
declare function NomCarreau (x as byte, y as byte) as string
declare sub Coordonnees ( carreau as string, byref x as byte, byref y as byte )
declare sub CoordonneesEcran (x    as byte,_
                              y    as byte,_
                        byref xscr as integer,_
                        byref yscr as integer)
                        
declare function FEN as string
declare sub InitFromStringFEN ( s as string )

'*******************************************************************************

sub Initialise
  
  dim as byte x,y,i
  
  for y=10 to -1 step -1
    for x=-1 to 10
      Occupant(x,y)=HorsJeu
    next x
  next y
  
  restore
  for y=8 to 1 step -1
    for x=1 to 8
      read Occupant(x,y)
    next x
  next y
  
  Trait=Blanc
  
  for i=e8c8 to e1g1
    Primo(i)=Vrai
  next i
  
  CarreauPassant="-"
  
  CompteDemiCoups=0
  
  CompteCoups=1
  
  Partie=""
  
end sub' Initialise

'*******************************************************************************

function NomCarreau ( x as byte, y as byte ) as string
  
  NomCarreau=chr(x+96)+chr(y+48)
  
end function

'*******************************************************************************

sub Coordonnees ( carreau as string, byref x as byte, byref y as byte )
  
  x=carreau[0]-96
  y=carreau[1]-48
  
end sub

'*******************************************************************************

sub CoordonneesEcran (x as byte, y as byte, byref xscr as integer,_
                                            byref yscr as integer)
  xscr=24+40*(x-1)
  yscr=24+40*((9-y)-1)
  
end sub

'*******************************************************************************

function FEN as string
  
  dim as string PP' Piece Placement
  dim as string AC' Active Color
  dim as string CA' Castling Availability
  dim as string TS' En Passant Target Square
  dim as string HC' Halfmove Clock
  dim as string FN' Fullmove Number
  
  dim as byte x, y, n=0
  dim as string s=""
  
  ' First field
  
  PP=""
  
  for y=8 to 1 step -1
    for x=1 to 8
        
      select case Occupant(x,y)
      
      case -Roi
        PP+="k"
        
      case -Dame
        PP+="q"
        
      case -Tour
        PP+="r"
        
      case -Fou
        PP+="b"
        
      case -Cavalier
        PP+="n"
        
      case -Pion
        PP+="p"
        
      case Vide
        n+=1
        if x=8 then
          PP+=str(n)
          n=0
        else
          if Occupant(x+1,y)<>Vide then
            PP+=str(n)
            n=0
          end if
        end if
        
      case Pion
        PP+="P"
        
      case Cavalier
        PP+="N"
        
      case Fou
        PP+="B"
        
      case Tour
        PP+="R"
        
      case Dame
        PP+="Q"
        
      case Roi
        PP+="K"
        
      end select
      
    next x
    
    if y > 1 then PP+="/"
    
  next y
  
  s+=PP & chr(32)
  
  ' Second field
  
  select case Trait
  case Blanc
    AC="w"
  case Noir
    AC="b"
  end select
  
  s+=AC & chr(32)
  
  ' Third field
  
  CA=""
  
  if Primo(e1g1)=Vrai then CA+="K"
  if Primo(e1c1)=Vrai then CA+="Q"
  if Primo(e8g8)=Vrai then CA+="k"
  if Primo(e8c8)=Vrai then CA+="q"
  
  if len(CA)=0 then CA="-"
  
  s+=CA & chr(32)
  
  ' Fourth field
  
  TS=CarreauPassant
  
  s+=TS & chr(32)
  
  ' Fifth field
  
  HC=str(CompteDemiCoups)
  
  s+=HC & chr(32)
  
  ' Sixth and last field
  
  FN=str(CompteCoups)
  
  s+=FN
  
  FEN=s
  
end function

'*******************************************************************************

sub InitFromStringFEN ( s as string )
  
  dim as byte i, j, n, x, y
  
  i=1' index chane
  
  ' First field
  
  n=0' 0  63
  
  do
    
    select case mid(s,i,1)
    case "k"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Roi
      i+=1
      n+=1
    case "q"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Dame
      i+=1
      n+=1
    case "r"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Tour
      i+=1
      n+=1
    case "b"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Fou
      i+=1
      n+=1
    case "n"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Cavalier
      i+=1
      n+=1
    case "p"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=-Pion
      i+=1
      n+=1
    case "P"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Pion
      i+=1
      n+=1
    case "N"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Cavalier
      i+=1
      n+=1
    case "B"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Fou
      i+=1
      n+=1
    case "R"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Tour
      i+=1
      n+=1
    case "Q"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Dame
      i+=1
      n+=1
    case "K"
      y=8-n\8
      x=n+1-8*(8-y)
      Occupant(x,y)=Roi
      i+=1
      n+=1
    case "1" to "8"
      for j=1 to valint(mid(s,i,1))
        y=8-n\8
        x=n+1-8*(8-y)
        Occupant(x,y)=Vide
        n+=1
      next j
      i+=1
    case "/"
      i+=1
    end select
    
  loop until n=64
  
  i+=1
  
  ' Second field
  
  select case mid(s,i,1)
  case "w"
    Trait=Blanc
    i+=1
  case "b"
    Trait=Noir
    i+=1
  end select
  
  i+=1
  
  ' Third field
  
  if mid(s,i,1)="K" then
    Primo(e1g1)=Vrai
    i+=1
  end if
  if mid(s,i,1)="Q" then
    Primo(e1c1)=Vrai
    i+=1
  end if
  if mid(s,i,1)="k" then
    Primo(e8g8)=Vrai
    i+=1
  end if
  if mid(s,i,1)="q" then
    Primo(e8c8)=Vrai
    i+=1
  end if
  if mid(s,i,1)="-" then
    for j=e8c8 to e1g1
      Primo(j)=Faux
    next j
    i+=1
  end if
  
  i+=1
  
  ' Fourth field
  
  if mid(s,i,1)="-" then
    CarreauPassant="-"
    i+=1
  else
    CarreauPassant=mid(s,i,2)
    i+=2
  end if
  
  i+=1
  
  ' Fifth field
  
  j=0
  
  do
    j+=1
  loop until mid(s,i+j,1)=chr(32)
  
  CompteDemiCoups=valint(mid(s,i,j))
  
  i+=1
  
  ' Sixth field
  
  j=0
  
  do
    j+=1
  loop until mid(s,i+j,1)=chr(32)
  
  CompteCoups=valint(mid(s,i,j))
  
end sub

'*******************************************************************************