'*******************************************************************************
'
' GRAPHISME
'
'*******************************************************************************

dim shared Figures (0 to 6, 1 to 40, 1 to 40) as byte

type Carreau
  dessiner as ubyte
  x as byte
  y as byte
end type

dim shared Carreaux (1 to 5) as Carreau' sub Mouvement

'*******************************************************************************

const c1=rgb(251,251,251)' .. fond tablier
const c2=rgb(000,000,063)'  dessin tablier
const c3=rgb(151,000,000)' . notifications
const c4=rgb(126,150,205)' .. fond console
const c5=rgb(201,201,201)' ... fond cadres
const c6=rgb(151,151,151)' .. fond boutons
const c7=rgb(127,127,127)' coups possibles
const c8=rgb(243,098,000)' .. dernier coup
const c9=rgb(175,175,175)'  cases blanches

'*******************************************************************************

declare sub OuvreFenetre
declare function CopieImages(f as string) as ubyte
declare function CarreauBlanc ( x as byte, y as byte ) as ubyte
declare sub DessineCarreau(x as byte,y as byte,occ as byte)
declare sub DessineTablier
declare sub DessineBoutons
declare sub ReDessineTablier

'*******************************************************************************

sub OuvreFenetre
  screenres 416,416,16,,4
  windowtitle "Eschecs"
  color c2,c4
  cls
end sub

'*******************************************************************************

function CopieImages(f as string) as ubyte
  dim as ubyte ff=freefile
  dim as integer defaut
  dim ligne as string
  dim as byte n, l, c
  
  defaut=open(f for input as #ff)
  if defaut=0 then
    
    while (n<6)
      
      line input #ff,ligne
      if left(ligne,1)="f" then
        
        n=valint(mid(ligne,2,1))
        
        for l=1 to 40
          
          line input #ff,ligne
          for c=1 to 40
            
            Figures(n,l,c)=valint(mid(ligne,c,1))
            
          next c
        next l
      end if
      
    wend
    
    close #ff
    return Vrai
    
  else
    return Faux
  end if
  
end function

'*******************************************************************************

function CarreauBlanc ( x as byte, y as byte ) as ubyte
  
  if ( (x+y) mod 2 ) = 0 then return Faux else return Vrai
  
end function

'*******************************************************************************

sub DessineCarreau ( x as byte, y as byte, occ as byte )
  
  dim as integer a, b
  dim as byte n, l, c
  
  color Iif(sgn(occ)=1,c3,c2),Iif(CarreauBlanc(x,y)=Vrai,c5,c9)
  
  a=40*x-16
  b=328-(40*y-16)
  
  n=abs(occ)
  
  a-=1
  b-=1
  
  for l=1 to 40
    for c=1 to 40
      
      if Figures(n,l,c)=1 then pset(a+c,b+l) else preset(a+c,b+l)
      
    next c
  next l
  color c2
end sub

'*******************************************************************************

sub DessineTablier
  dim as byte x,y
  color c2,c1
  
  for y=8 to 1 step -1
    for x=1 to 8
      DessineCarreau(x,y,Occupant(x,y))
    next x
  next y
  
end sub

'*******************************************************************************

sub ReDessineTablier
  dim i as byte
  dim as integer xscr, yscr
  color c2,c1
  for i=1 to 5
    if Carreaux(i).dessiner = Vrai then
      
      DessineCarreau (Carreaux(i).x,_
                      Carreaux(i).y,_
                      Occupant(Carreaux(i).x,Carreaux(i).y))
      if i=2 then
        CoordonneesEcran (Carreaux(i).x,Carreaux(i).y,xscr,yscr)
        'line (xscr,yscr)-(xscr+39,yscr+39),c8,b
      end if
      
    end if
  next i
end sub

'*******************************************************************************

sub DessineBoutons
  
    line (0,0)-(415,415),,b
    
    for i as byte=1 to 4
      if i=2 then color c5 else color c2
      line (024-i,024-i)-(343+i,343+i),,b
      line (368-i,024-i)-(391+i,047+i),,b
      line (368-i,064-i)-(391+i,087+i),,b
      line (368-i,104-i)-(391+i,127+i),,b
      line (368-i,368-i)-(391+i,391+i),,b
      line (024-i,368-i)-(143+i,391+i),,b
      line (256-i,368-i)-(279+i,391+i),,b
      line (296-i,368-i)-(343+i,391+i),,b
    next i
    
    line (368,024)-(368+24-1,024+24-1),c6,bf
    line (368,064)-(368+24-1,064+24-1),c6,bf
    line (368,104)-(368+24-1,104+24-1),c6,bf
    line (024,368)-(24+120-1,368+24-1),c1,bf
    line (256,368)-(256+24-1,368+24-1),c1,bf
    line (296,368)-(296+48-1,368+24-1),c1,bf
    line (368,368)-(368+24-1,368+24-1),c3,bf
    
    color c3
    draw string (368,040),chr(9,9,9)
    draw string (368,040),chr(7,7,7)
    color c2
    draw string (368,064),chr(9,9,9)
    draw string (368,064),chr(7,7,7)
    draw string (368,104),chr(9,9,9)
    draw string (368,104),chr(7,7,7)
    color c3
    draw string (368,120),chr(9,9,9)
    draw string (368,120),chr(7,7,7)
    color c1
    draw string (372,372),"ex"
    draw string (372,380),"it"
    color c2
end sub

'*******************************************************************************

sub AffCoordonnees
    for i as byte=0 to 7
      draw string (i*40+40,9),chr(097+i)
      draw string (9,i*40+41),chr(056-i)
    next i
end sub

'*******************************************************************************