'*******************************************************************************
'
' MOUVEMENTS DES PIECES
'
'*******************************************************************************

declare function MouvementNaturel (x1   as byte,_
                                   y1   as byte,_
                                   x2   as byte,_
                                   y2   as byte,_
                                   oc() as byte)_
                                   as ubyte

'*******************************************************************************

function MouvementNaturel (x1   as byte,_
                           y1   as byte,_
                           x2   as byte,_
                           y2   as byte,_
                           oc() as byte)_
                           as ubyte
                           
  dim as byte dx=x2-x1
  dim as byte dy=y2-y1
  dim as byte coul=sgn(oc(x1,y1))
  dim as byte vx, vy, i
  
  select case as const abs(oc(x1,y1))
  
  case Pion
    
    if (dx=0) andalso (oc(x2,y2)=Vide) then
      if (dy=1*coul) then return Vrai
      if ((y1=2) andalso (coul=Blanc)) or ((y1=7) andalso (coul=Noir)) then
        if (dy=2*coul) andalso (oc(x1,y1+1*coul)=Vide) then return Vrai
      end if
    end if
    
    if abs(dx)=1 andalso dy=1*coul then return Vrai
    
  case Cavalier
    
    if dx*dx+dy*dy=5 then return Vrai
    
  case Fou
    
    if (abs(dx)=abs(dy)) andalso (abs(dx)>0) then
      if abs(dx)=1 then
        return Vrai
      else
        vx=sgn(dx)
        vy=sgn(dy)
        i=0
        do
          i+=1
          if not (oc(x1+i*vx, y1+i*vy)=Vide) then return Faux
        loop until (i=abs(dx)-1)
        return Vrai
      end if
    end if
    
  case Tour
    
    if (dx*dy=0) andalso (abs(dx)+abs(dy)>0) then
      if abs(dx)+abs(dy)=1 then
        return Vrai
      else
        vx=sgn(dx)
        vy=sgn(dy)
        i=0
        do
          i+=1
          if not (oc(x1+i*vx,y1+i*vy)=Vide) then return Faux
        loop until (i=abs(dx)+abs(dy)-1)
        return Vrai
      end if
    end if
    
  case Dame
    
    if (abs(dx)=abs(dy)) andalso (abs(dx)>0) then
      if abs(dx)=1 then
        return Vrai
      else
        vx=sgn(dx)
        vy=sgn(dy)
        i=0
        do
          i+=1
          if not (oc(x1+i*vx,y1+i*vy)=Vide) then return Faux
        loop until (i=abs(dx)-1)
        return Vrai
      end if
    end if
    
    if (dx*dy=0) andalso (abs(dx)+abs(dy)>0) then
      if abs(dx)+abs(dy)=1 then
        return Vrai
      else
        vx=sgn(dx)
        vy=sgn(dy)
        i=0
        do
          i+=1
          if not (oc(x1+i*vx,y1+i*vy)=Vide) then return Faux
        loop until (i=abs(dx)+abs(dy)-1)
        return Vrai
      end if
    end if    
    
  case Roi
    
    if (dx*dx<2) and (dy*dy<2) and (dx*dx+dy*dy>0) then return Vrai
    
    if (abs(dx)=2) and (dy=0) then
      
      if (x2=3) then
        if (oc(2,y2)=0) and (oc(3,y2)=0) and (oc(4,y2)=0) then
          
          select case NomCarreau(x1,y1)
          case "e8"
            if oc(1,y2)=Tour*Noir then return Vrai
          case "e1"
            if oc(1,y2)=Tour*Blanc then return Vrai
          end select
          
        end if
      end if
      
      if (x2=7) then
        if (oc(6,y2)=0) and (oc(7,y2)=0) then
          
          select case NomCarreau(x1,y1)
          case "e8"
            if oc(8,y2)=Tour*Noir then return Vrai
          case "e1"
            if oc(8,y2)=Tour*Blanc then return Vrai
          end select
          
        end if
      end if
      
    end if
    
  end select
  
  return Faux
  
end function

'*******************************************************************************